# Virtru TDF3 SDK

## License

The following files are covered under the MIT license:

* virtru_sample.py
* __init__.py
* setup.py

The following binaries / minified libraries are subject to use under the "Virtru Data Protection Subscription Agreement" 
found here: https://www.virtru.com/terms-of-service/ 

* virtru_tdf3_python.pyd
* virtru_tdf3_python.so

All 3rd party packages used in this software are covered by their respective
licenses, which are detailed in the LICENSE file.

## Obtaining a Virtru AppId

 A Virtru `AppId` token is required to use the TDF3 SDK. [This is how you obtain it](https://developer.virtru.com/docs/how-to-download-appid-token) 

## The Virtru TDF3 Python Sample

For more information on how to use the TDF3 Python module, see the [online documentation](https://docs.developer.virtru.com/python/latest).

### General
+ [Python](http://www.python.org "Python home page") This module is built with Python3 libraries so it will ONLY work
with python3.

The module works on Linux, Windows and OSX. 

## Installing the module

### OS X And Linux
+ Navigate to `cd lib` and run `sudo python3 setup.py install`. The Virtru SDK module will build and install the module to `site-packages`.

```
$ sudo python3 setup.py install
running install
running build
running build_py
creating build
creating build/lib
creating build/lib/virtru_tdf3_python
copying virtru_tdf3_python/__init__.py -> build/lib/virtru_tdf3_python
copying virtru_tdf3_python/virtru_tdf3_python.so -> build/lib/virtru_tdf3_python
running install_lib
copying build/lib/virtru_tdf3_python/__init__.py -> /usr/local/lib/python3.7/site-packages/virtru_tdf3_python
copying build/lib/virtru_tdf3_python/virtru_tdf3_python.so -> /usr/local/lib/python3.7/site-packages/virtru_tdf3_python
byte-compiling /usr/local/lib/python3.7/site-packages/virtru_tdf3_python/__init__.py to __init__.cpython-37.pyc
running install_egg_info
Writing /usr/local/lib/python3.7/site-packages/virtru_tdf3_python-1.0.11-py3.7.egg-info
```

### Windows

`Make sure the Python installed on your windows machine is 64-bit.`

+ Navigate to `cd lib` and run `python setup.py install` and will build and install the module to `site-packages`.

```
PS C:\Users\..\lib> python setup.py install
running install
running build
running build_py
creating build
creating build\lib
creating build\lib\virtru_tdf3_python
copying virtru_tdf3_python\__init__.py -> build\lib\virtru_tdf3_python
copying virtru_tdf3_python\virtru_tdf3_python.pyd -> build\lib\virtru_tdf3_python
running install_lib
copying build\lib\virtru_tdf3_python\virtru_tdf3_python.pyd -> C:\Users\sujan\AppData\Local\Programs\Python\Python37\Lib\site-packages\virtru_tdf3_python
copying build\lib\virtru_tdf3_python\__init__.py -> C:\Users\sujan\AppData\Local\Programs\Python\Python37\Lib\site-packages\virtru_tdf3_python
byte-compiling C:\Users\sujan\AppData\Local\Programs\Python\Python37\Lib\site-packages\virtru_tdf3_python\__init__.py to __init__.cpython-37.pyc
running install_egg_info
Writing C:\Users\sujan\AppData\Local\Programs\Python\Python37\Lib\site-packages\virtru_tdf3_python-1.0.10-py3.7.egg-info
```

## Running the sample

+ Navigate to the `sample` directory and update `virtru_sample.py` script with your `AppId`
 
+ Run `python3 virtru_sample.py` to see how the files in the sample directory get encrypted and how to apply controls.
